<?php
require_once('phprpc_server.php');

$mp3player_backColor = "990000";
$mp3player_frontColor = "ddddff";

define('ENABLED_MBSTRING_PHPRPC', true);

if (defined('ENABLED_MBSTRING_PHPRPC') && ENABLED_MBSTRING_PHPRPC) {
    require_once('phprpc_client.php');
    $coolplayer_rpcpath = "http://www.coolcode.cn/wp-content/plugins/coolplayer/mbstring.php";
    $rpc_client = new phprpc_client($coolplayer_rpcpath);
}

if (extension_loaded('mbstring')) {
    function mb_urlencode($url, $charset) {
        $len = mb_strlen($url, $charset);
        $result = "";
        for ($i = 0; $i < $len; $i++) {
            $c = mb_substr($url, $i, 1, $charset);
            if (strlen($c) > 1) $c = urlencode($c);
            $result .= $c;
        }
        return $result;
    }
}
else if (extension_loaded('iconv')) {
    function mb_convert_encoding($str, $to_encoding, $from_encoding) {
        return iconv($from_encoding, $to_encoding, $str);
    }
    if (version_compare(phpversion(), "5", ">=")) {
        function mb_urlencode($url, $charset) {
            $len = iconv_strlen($url, $charset);
            $result = "";
            for ($i = 0; $i < $len; $i++) {
                $c = iconv_substr($url, $i, 1, $charset);
                if (strlen($c) > 1) $c = urlencode($c);
                $result .= $c;
            }
            return $result;
        }
    }
    else if (defined('ENABLED_MBSTRING_PHPRPC') && ENABLED_MBSTRING_PHPRPC) {
        function mb_urlencode($url, $charset) {
            global $rpc_client;
            $result = $rpc_client->mb_urlencode($url, $charset);
            if (get_class($result) == "phprpc_error") {
                return $url;
            }
            else {
                return $result;
            }
        }
    }
    else {
        function mb_urlencode($url, $charset) {
            return $url;
        }
    }
}
else if (defined('ENABLED_MBSTRING_PHPRPC') && ENABLED_MBSTRING_PHPRPC) {
    function mb_urlencode($url, $charset) {
        global $rpc_client;
        $result = $rpc_client->mb_urlencode($url, $charset);
        if (get_class($result) == "phprpc_error") {
            return $url;
        }
        else {
            return $result;
        }
    }
    function mb_convert_encoding($str, $to_encoding, $from_encoding) {
        global $rpc_client;
        $result = $rpc_client->mb_convert_encoding($str, $to_encoding, $from_encoding);
        if (get_class($result) == "phprpc_error") {
            return $str;
        }
        else {
            return $result;
        }
    }
}
else {
    function mb_urlencode($url, $charset) {
        return $url;
    }
    function mb_convert_encoding($str, $to_encoding, $from_encoding) {
        return $str;
    }
}

function fetchURL($url) {
    $url_parsed = parse_url($url);
    $host = $url_parsed["host"];
    if (!isset($url_parsed["port"])) {
        $port = 80;
    }
    else {
        $port = $url_parsed["port"];
    }
    $path = $url_parsed["path"];
    if ($url_parsed["query"] != "") $path .= "?" . $url_parsed["query"];
    $out = "GET $path HTTP/1.0\r\nHost: $host\r\n\r\n";
    $fp = fsockopen($host, $port, $errno, $errstr, 30);
    fwrite($fp, $out);
    $body = false;
    $in = "";
    while (!feof($fp)) {
        $s = fgets($fp, 1024);
        if ($body) $in .= $s;
        if ($s == "\r\n") $body = true;
    }
    fclose($fp);
    return $in;
}

function to_fullpath($url) {
    $urlparts = parse_url($url);
    $host = "";
    $path = "";
    if (!isset($urlparts['host'])) {
        if (isset($_SERVER["HTTP_HOST"])) {
            $host = $_SERVER["HTTP_HOST"];
        }
        else if (isset($_SERVER["SERVER_NAME"])) {
            $$host = $_SERVER["SERVER_NAME"];
        }
        else {
            $host = "localhost";
        }
        if (!isset($_SERVER["HTTPS"]) ||
            $_SERVER["HTTPS"] == "off"  ||
            $_SERVER["HTTPS"] == "") {
            $host = "http://" . $host;
            if ($_SERVER["SERVER_PORT"] != "80") {
                $host .= ":" . $_SERVER["SERVER_PORT"];
            }
        }
        else {
            $host = "https://" . $host;
            if ($_SERVER["SERVER_PORT"] != "443") {
                $host .= ":" . $_SERVER["SERVER_PORT"];
            }
        }
    }
    if (!isset($urlparts['path'])) {
        $path = "/";
    }
    else if (($urlparts['path']{0} != '/') && ($_SERVER["PHP_SELF"]{0} == '/')) {
        $path = substr($_SERVER["PHP_SELF"], 0, strrpos($_SERVER["PHP_SELF"], '/') + 1);
    }
    $url = $host . $path . $url;
    return $url;
}

function coolplayer_init_url(&$url, &$info, &$type, $from_charset, $to_charset) {
    if (preg_match('/\<a (.*?)\>(.*?)\<\/a\>/i', $url, $match)) {
        $info = $match[2];
        $a_option = $match[1];
        if (preg_match('/href\s*=\s*\\"(.*?)\\"/i', $a_option, $match) or
            preg_match("/href\s*=\s*\\'(.*?)\\'/i", $a_option, $match)) {
            $url = $match[1];
        }
    }
    else {
        $urlparts = parse_url($url);
        if (isset($urlparts['path'])) {
            $info = basename($urlparts['path']);
            if ($info == "") $info = $urlparts['path'];
        }
        else {
            $info = $url;
        }
    }
    $url = to_fullpath($url);
    $url = mb_convert_encoding($url, $to_charset, $from_charset);
    $url = mb_urlencode($url, $to_charset);
    $url = str_replace(" ", "%20", $url);

    $type = explode(".", $url);
    $type = trim(strtolower($type[count($type) - 1]));
}

function is_youtube_video(&$url, &$info, &$type) {
    if ((strpos(strtolower($url), 'http://www.youtube') === 0) ||
        (strpos(strtolower($url), 'http://youtube') === 0)) {
        if (preg_match('/v=([^(\&|$)]*)/', $url, $match) || 
            preg_match('/video_id=([^(\&|$)]*)/', $url, $match) ||
            preg_match('/youtube\.com\/v\/([^(\&|$)]*)/', $url, $match)) {
            $video_id = $match[1];
            $type = "flv";
            $url = "http://youtube.com/get_video.php?video_id=$video_id";
            if (strpos($info, $video_id) !== false) {
                $info = "YouTube Video";
            }
            return true;
        }
    }
    return false;
}

function is_google_video(&$url, &$info, &$type, &$thumb) {
    if (strpos(strtolower($url), 'http://video.google') === 0) {
        $thumb = "";
        if (preg_match('/videoUrl=([^(\&|$)]*)/', $url, $match)) {
            $video_url = urldecode($match[1]);
            if ((strpos($info, $match[1]) !== false) ||
                ($info == "googleplayer.swf")) {
                $info = "Google Video";
            }
            if (preg_match('/thumbnailUrl=([^(\&|$)]*)/', $url, $match)) {
                $thumb = $match[1];
            }
            $type = 'flv';
            $url = 'http://www.anonymization.org/-' . substr($video_url, 7);
            return true;
        }
        else {
            if (preg_match('/docid=([^(\&|$)]*)/', $url, $match)) {
                $docid = $match[1];
                $content = fetchURL('http://www.anonymization.org/-video.google.com/videoplay?docid=' . $docid);
                if (preg_match('/videoUrl=([^(\&)]*)/', $content, $match)) {
                    $video_url = urldecode($match[1]);
                    if ((strpos($info, $match[1]) !== false) ||
                        ($info == "videoplay")) {
                        $info = "Google Video";
                    }
                    if (preg_match('/thumbnailUrl=([^(\&)]*)/', $content, $match)) {
                        $thumb = $match[1];
                    }
                    $type = "flv";
                    $url = 'http://www.anonymization.org/-' . substr($video_url, 7);
                    return true;
                }
            }
        }
    }
    return false;
}

function is_vsocial_video(&$url, &$info, &$type) {
    if ((strpos(strtolower($url), 'http://www.vsocial.com') === 0) ||
        (strpos(strtolower($url), 'http://vsocial.com') === 0)) {
        if (preg_match('/v=([^(\&|$)]*)/', $url, $match) || 
            preg_match('/vsocial\.com\/v\/([^(\&|$)]*)/', $url, $match)) {
            $video_id = $match[1];
            $type = "flv";
            $url = "http://www.vsocial.com/varmedia/vsocial/flv/{$video_id}_out.flv";
            if ((strpos($info, $video_id) !== false) ||
                ($info == 'e.swf') || ($info == 'vp.swf')) {
                $info = "Vsocial Video";
            }
            return true;
        }
        else {
            if (preg_match('/d=([^(\&|$)]*)/', $url, $match)) {
                $docid = $match[1];
                $content = fetchURL("http://vsocial.com/video/?d=" . $docid);
                if (preg_match("/vp\.swf\?v=([^(\')]*)/", $content, $match)) {
                    $video_id = $match[1];
                    $type = "flv";
                    $url = "http://www.vsocial.com/varmedia/vsocial/flv/{$video_id}_out.flv";
                    if ((strpos($info, $match[1]) !== false) ||
                        ($info == "") || ($info == "index.php")) {
                        $info = "Vsocial Video";
                    }
                    return true;
                }
            }
        }
    }
    return false;
}

function coolplayer_mp3color() {
    global $mp3player_backColor, $mp3player_frontColor;
           
    if (strlen($mp3player_backColor) > 6) {
        $mp3player_backColor = substr($mp3player_backColor, 1, 6);
    }

    if (strlen($mp3player_frontColor) > 6) {
        $mp3player_frontColor = substr($mp3player_frontColor, 1, 6);
    }

    return "&amp;backColor=$mp3player_backColor&amp;frontColor=$mp3player_frontColor";
}

function coolplayer_init_media(&$url, &$info, &$type,
                               &$src, &$func, &$mime,
                               &$width, &$height, &$autoplay, &$loop) {
                              
    global $coolplayer_default_pluginpath;
    $pluginpath = $coolplayer_default_pluginpath;

// flash

    $src = $url;
    $func = 'coolplayer_flash';
    $mime = 'application/x-shockwave-flash';

    if ($type == 'swf') {
        return true;
    }

    if ($type == 'spl') {
        $mime = 'application/futuresplash';
        return true;
    }

    if ($type == 'mp3') {
        $autoplay = (($autoplay == '1') ? 'true' : 'false');
        $loop = (($loop == '1') ? 'true' : 'false');
        $src = $pluginpath .
               '/singlemp3player.swf?file=' .
               htmlentities(urlencode($url)) .
               "&amp;autoStart=$autoplay&amp;repeatPlay=$loop" .
               coolplayer_mp3color();
        $height = 20;
        $autoplay = 'true';
        $loop = 'false';
        return true;
    }

    if (is_youtube_video($url, $info, $type) ||
        is_vsocial_video($url, $info, $type) ||
        ($type == 'flv')) {
        $src = $pluginpath .
               '/flvplayer.swf?file=' .
               htmlentities(urlencode($url)) .
               "&amp;autoStart=$autoplay&amp;repeatPlay=$loop";
        $height += 20;
        $autoplay = 'true';
        $loop = 'false';
        return true;
    }

    if (is_google_video($url, $info, $type, $thumb)) {
        $src = $pluginpath .
               '/googleplayer.swf?videoUrl=' .
               htmlentities(urlencode($url)) .
               "&amp;thumbnailUrl=$thumb&amp;playerMode=embedded";
        $height += 27;
        $autoplay = 'true';
        return true;
    }

//quicktime
    $func = 'coolplayer_qt';

    if (in_array($type, array('mov', 'qt', 'mqv'))) {
        $mime = 'video/quicktime';
        return true;
    }

    if (in_array($type, array('mpeg', 'mpg', 'm1s', 'm1v', 'm1a', 'm75', 'm15', 'mp2', 'mpm', 'mpv', 'mpa'))) {
        $mime = 'video/x-mpeg';
        return true;
    }

    if (in_array($type, array('flc', 'fli', 'cel'))) {
        $mime = 'video/flc';
        return true;
    }

    if (in_array($type, array('rtsp', 'rts'))) {
        $mime = 'application/x-rtsp';
        return true;
    }
    
    if (in_array($type, array('3gp', '3gpp'))) {
        $mime = 'video/3gpp';
        return true;
    }

    if (in_array($type, array('3g2', '3gp2'))) {
        $mime = 'video/3gpp2';
        return true;
    }

    if ($type == 'sdv') {
        $mime = 'video/sd-video';
        return true;
    }

    if ($type == 'amc') {
        $mime = 'application/x-mpeg';
        return true;
    }

    if ($type == 'mp4') {
        $mime = 'video/mp4';
        return true;
    }

    if ($type == 'sdp') {
        $mime = 'application/sdp';
        return true;
    }

//real media

    if (in_array($type, array('rm', 'rmvb', 'ra', 'rv', 'ram', 'smil'))) {
        $src = $pluginpath . "/coolplayer.php?coolplayer_url=" . htmlentities(urlencode($url));
        $func = 'coolplayer_rm';
        $mime = 'audio/x-pn-realaudio-plugin';
        return true;
    }

//windows media
    if (in_array($type, array('asf', 'asx', 'wm', 'wma', 'wmv', 'wax', 'wvx', 'ogg', 'ape', 'avi', 'mid', 'midi', 'wav'))) {
        $func = 'coolplayer_wm';
        $mime = 'application/x-mplayer2';
        return true;
    }

//acrobat pdf
    $func = 'coolplayer_pdf';

    if ($type == 'pdf') {
        $mime = 'application/pdf';
        return true;
    }

    if ($type == 'fdf') {
        $mime = 'application/vnd.fdf';
        return true;
    }

    if ($type == 'xfdf') {
        $mime = 'application/vnd.adobe.xfdf';
        return true;
    }

    if ($type == 'xdp') {
        $mime = 'application/vnd.adobe.xdp+xml';
        return true;
    }

    if ($type == 'xfd') {
        $mime = 'application/vnd.adobe.xfd+xml';
        return true;
    }

//images
    $func = 'coolplayer_img';
    
    if (in_array($type, array('gif', 'jpg', 'jpeg', 'bmp', 'png', 'xpm'))) {
        $mime = 'image';
        return true;
    }

//unknown
    $func = 'coolplayer_unknown';
    $mime = '';
    return false;
}

$coolplayer_default_pluginpath = to_fullpath(substr($_SERVER["PHP_SELF"], 0, strrpos($_SERVER["PHP_SELF"], '/')));

function play_media($url, $id, $width, $height, $autoplay, $loop, $charset) {
    $url = trim(strip_tags($url, '<a>'));
    coolplayer_init_url($url, $info, $type, 'utf-8', $charset);
    coolplayer_init_media($url, $info, $type, $src, $func, $mime, $width, $height, $autoplay, $loop);
    return array('url' => $url,
                 'info' => $info,
                 'id' => $id,
                 'src' => $src,
                 'func' => $func,
                 'mime' => $mime,
                 'width' => $width,
                 'height' => $height,
                 'autoplay' => $autoplay,
                 'loop' => $loop);
}

new phprpc_server(array('play_media'));
?>